
Table of Contents
=================

* [Brook](#brook)
* [Getting Started 快速上手](#getting-started-快速上手)
   * [Server](#server)
   * [Client](#client)
* [Install CLI 安装命令行](#install-cli-安装命令行)
   * [nami](#nami)
   * [brook](#brook-1)
   * [joker](#joker)
   * [jinbe](#jinbe)
   * [tun2brook](#tun2brook)
   * [via pacman](#via-pacman)
   * [via brew](#via-brew)
   * [via docker](#via-docker)
* [Install GUI 安装图形客户端](#install-gui-安装图形客户端)
   * [iOS / M1 Mac](#ios--m1-mac)
   * [Android APK](#android-apk)
   * [Intel Mac](#intel-mac)
   * [Windows EXE](#windows-exe)
   * [Linux GUI](#linux-gui)
   * [OpenWrt IPK](#openwrt-ipk)
* [CLI Documentation 命令行文档](#cli-documentation-命令行文档)
* [NAME](#name)
* [SYNOPSIS](#synopsis)
* [GLOBAL OPTIONS](#global-options)
* [COMMANDS](#commands)
   * [server](#server-1)
   * [client](#client-1)
   * [wsserver](#wsserver)
   * [wsclient](#wsclient)
   * [wssserver](#wssserver)
   * [wssclient](#wssclient)
   * [quicserver](#quicserver)
   * [quicclient](#quicclient)
   * [relayoverbrook](#relayoverbrook)
   * [dnsserveroverbrook](#dnsserveroverbrook)
   * [tproxy](#tproxy)
   * [link](#link)
   * [connect](#connect)
   * [relay](#relay)
   * [dnsserver](#dnsserver)
   * [dnsclient](#dnsclient)
   * [dohserver](#dohserver)
   * [dohclient](#dohclient)
   * [dhcpserver](#dhcpserver)
   * [socks5](#socks5)
   * [socks5tohttp](#socks5tohttp)
   * [pac](#pac)
   * [testsocks5](#testsocks5)
   * [testbrook](#testbrook)
   * [echoserver](#echoserver)
   * [echoclient](#echoclient)
   * [completion](#completion)
   * [mdpage](#mdpage)
      * [help, h](#help-h)
   * [manpage](#manpage)
   * [help, h](#help-h-1)
* [GUI Documentation](#gui-documentation)
   * [Software for which this article applies](#software-for-which-this-article-applies)
   * [Intel Mac GUI proxy mode, Windows GUI proxy mode, Linux GUI proxy mode](#intel-mac-gui-proxy-mode-windows-gui-proxy-mode-linux-gui-proxy-mode)
   * [iOS, M1 Mac GUI, Android GUI, Intel Mac GUI tun mode, Windows GUI tun mode, Linux GUI tun mode](#ios-m1-mac-gui-android-gui-intel-mac-gui-tun-mode-windows-gui-tun-mode-linux-gui-tun-mode)
   * [Configuration Introduction](#configuration-introduction)
   * [Programmable](#programmable)
      * [Introduction to incoming variables](#introduction-to-incoming-variables)
      * [in_guiconfig](#in_guiconfig)
      * [in_dnsquery](#in_dnsquery)
      * [in_address](#in_address)
      * [in_httprequest](#in_httprequest)
      * [in_httpresponse](#in_httpresponse)
      * [How to write Tengo script](#how-to-write-tengo-script)
      * [How to debug script](#how-to-debug-script)
   * [Why and How to Turn Off System and Browser Security DNS](#why-and-how-to-turn-off-system-and-browser-security-dns)
   * [Install CA](#install-ca)
      * [iOS](#ios)
      * [Android](#android)
      * [macOS](#macos)
      * [Windows](#windows)
   * [Apple Push Problem](#apple-push-problem)
* [图形客户端文档](#图形客户端文档)
   * [本文适用的软件](#本文适用的软件)
   * [Intel Mac GUI proxy 模式, Windows GUI proxy 模式, Linux GUI proxy 模式](#intel-mac-gui-proxy-模式-windows-gui-proxy-模式-linux-gui-proxy-模式)
   * [iOS, M1 Mac GUI, Android GUI, Intel Mac GUI tun 模式, Windows GUI tun 模式, Linux GUI tun 模式](#ios-m1-mac-gui-android-gui-intel-mac-gui-tun-模式-windows-gui-tun-模式-linux-gui-tun-模式)
   * [配置介绍](#配置介绍)
   * [Programmable](#programmable-1)
      * [传入变量介绍](#传入变量介绍)
      * [in_guiconfig](#in_guiconfig-1)
      * [in_dnsquery](#in_dnsquery-1)
      * [in_address](#in_address-1)
      * [in_httprequest](#in_httprequest-1)
      * [in_httpresponse](#in_httpresponse-1)
      * [如何写 Tengo 脚本](#如何写-tengo-脚本)
      * [如何调试脚本](#如何调试脚本)
   * [为什么以及如何关闭系统和浏览器安全 DNS](#为什么以及如何关闭系统和浏览器安全-dns)
   * [安装 CA](#安装-ca)
      * [iOS](#ios-1)
      * [Android](#android-1)
      * [macOS](#macos-1)
      * [Windows](#windows-1)
   * [Apple 推送问题](#apple-推送问题)
* [Diagram 图解](#diagram-图解)
   * [overview](#overview)
   * [withoutBrookProtocol](#withoutbrookprotocol)
   * [relayoverbrook](#relayoverbrook-1)
   * [dnsserveroverbrook](#dnsserveroverbrook-1)
   * [relay](#relay-1)
   * [dnsserver](#dnsserver-1)
   * [tproxy](#tproxy-1)
   * [gui](#gui)
   * [script](#script)

